## ------------------------------------------------------------------------
## Erzeuge ein temporäres Verzeichnis tmp im aktuellen Arbeitsverzeichnis
dir.create("tmp")
## Mache tmp zum aktuellen Arbeitsverzeichnis
setwd("tmp")
## Erzeuge die Dateien A.txt und B.txt
cat("Dies ist die Datei A.txt\n", file="A.txt")
cat("Dies ist die Datei B.txt\n", file="B.txt")
## Hänge B.txt an A.txt an
file.append(file1 = "A.txt", file2 = "B.txt")
## Liste die Dateien im aktuellen Arbeitsverzeichnis auf
list.files()
## Abfragen der Zugriffsrechte von A.txt
file.mode("A.txt") ## 6 = lesen + schreiben, 4 = lesen
## Entfernen von Datei B.txt
file.remove("B.txt")
## Auflisten der Dateien
list.files()
## Verlasse Verzeichnis tmp
setwd("../")
## Lösche Verzeichnis tmp inkl. der Datei A.txt
unlink("tmp", recursive = TRUE)

## ------------------------------------------------------------------------
## Anlegen einer einfachen R-Datei - besser mittels Editor anlegen!
cat("x <- rnorm(10)\n", file = "Test.R")
source("Test.R")
x
source("Test.R", echo = TRUE)
x ## neue Zufallszahlen, nicht identisch zu vorangegangenen

## ------------------------------------------------------------------------
search()
objects()
## auch die versteckten Objekte (d.h., Name beginnt mit ".")
objects(all.names = TRUE)

## ------------------------------------------------------------------------
## Anlegen des Objekts Obj in .GlobalEnv
Obj <- "GlobalEnv"
## Wir legen ein neues Environment an
env1 <- new.env()
## Wir legen in env1 ein Objekt mit Namen Obj ab
assign("Obj", value = "Environment 1", envir = env1)
## Dieses Objekt können wir nun mit Hilfe von get aufrufen
get("Obj", envir = env1)
## Wir legen ein weiteres Environment an
env2 <- new.env()
## Wieder erzeugen wir darin ein Objekt mit Namen Obj
assign("Obj", value = "Environment 2", envir = env2)
get("Obj", envir = env2)
## Wir lassen nach einem Objekt mit Namen Obj suchen
## Als erstes gefunden und ausgegeben wird das Objekt Obj im .GlobalEnv
Obj
## Wo überall gibt es ein Objekt mit Namen Obj?
getAnywhere("Obj")
## Es wird nur das Objekt im .GlobalEnv gefunden, da env1 und env2
## nicht automatisch in den Suchpfad aufgenommen werden
search()
## Die Namen welcher Objekte beginnen mit Obj?
apropos("^Obj", ignore.case = FALSE)
## Wo finde ich das Objekt mit Namen Obj?
find("Obj")
## Wir fügen env1 und env2 zum Suchpfad hinzu
attach(env1)
attach(env2)
## immer noch
Obj
## Wo finde ich jetzt überall ein Objekt mit Namen Obj?
find("Obj")
getAnywhere("Obj")
## Wir entfernen Obj; d.h., das Objekt mit Namen Obj in .GlobalEnv
rm(Obj)
## jetzt
Obj
## klar, env2 vor env1 im Suchpfad
search()
## wir entfernen env2 vom Suchpfad
detach(env2)
## jetzt
Obj
## klar, env1 im Suchpfad ganz vorne
search()
## Wir können env1 auch vom Suchpfad entfernen, indem wir nur dessen Position
## im Suchpfad angeben
detach(2)
search()
## Wir löschen die beiden angelegten Environments
rm(env1, env2)

## ------------------------------------------------------------------------
## aktuell insgesamt 65 Optionen
length(options())
## Zum Beispiel
options()[1:5]

## ------------------------------------------------------------------------
## Vektor mit Eintrag der Option
getOption("digits")
## Teiliste mit Eintrag der Option
options("digits")
## Abändern der Option und speichern der alten Werte
op <- options("digits" = 10)
x <- rnorm(10)
x
## Zurücksetzen
options(op)
x

## ------------------------------------------------------------------------
## options(prompt = "R > ")
## options(repos = "http://cran.at.r-project.org")

## ------------------------------------------------------------------------
## .First <- function(){
##     options(prompt = "R > ")
##     options(repos = "http://cran.at.r-project.org")
## }

## ------------------------------------------------------------------------
## .Last <- function(){
##     cat("Auf Wiedersehen ...\n")
## }

## ------------------------------------------------------------------------
## ## Zum Beispiel
## history(max.show = 10)
## savehistory()
## loadhistory()

