## ------------------------------------------------------------------------
## Addition
1+1
## Subtraktion
1-1
## Multiplikation
5*2
## Division
5/2
## Potenzbildung
5^2
## Rechnen mit Rest
5 %% 2
## integer-Division
5 %/% 2

## ------------------------------------------------------------------------
###########################################################
## Quadratwurzel
sqrt(1:10)
###########################################################
## Exponentialfunktion
exp(3)
## Für Werte << 1 erzielt man eine höhere Rechengenaugikeit, falls man
## anstelle von
x <- exp(1e-10)-1
x
## folgende Funktion verwendet
y <- expm1(1e-10)
y
x-y
###########################################################
## Natürlicher Logarithmus
log(3)
## Basis 10
log10(100)
## Basis 2
log2(8)
## beliebige Basis
log(3, base = 7)
## oder
logb(3, base = 7)
## Für Werte << 1 erzielt man eine höhere Rechengenaugikeit, falls man
## anstelle von
x <- log(1 + 1e-10)
x
## folgende Funktion verwendet
y <- log1p(1e-10)
y
x-y

## ------------------------------------------------------------------------
###########################################################
## Trigonometrische Funktionen
sin(pi)
cos(pi)
tan(pi)
asin(1)
acos(1)
atan(1)
###########################################################
## Winkel zwischen x-Achse und Vektor zum Punkt (x,y)
atan2(x = 0, y = 1) ## 90 Grad = pi/2
###########################################################
## Hyperbolische Funktionen
cosh(1)
sinh(2)
tanh(3)
asinh(4)
acosh(5)
atanh(0.1)

## ------------------------------------------------------------------------
x <- 1:5
y <- rnorm(10) ## 10 Zufallszahlen
exp(y)+x

## ------------------------------------------------------------------------
exp(y) + rep(x, 2)

## ------------------------------------------------------------------------
3 + TRUE
2 * FALSE
## oder auch
sqrt(-2) ## NaN = Not a Number (nicht wohldefiniert)
## bzw. die komplexe Quadratwurzel
sqrt(-2 + 0i)

## ------------------------------------------------------------------------
gamma(4) ## = (4-1)!
factorial(3) ## = gamma(3+1)!
## Definition via gamma
factorial

## ------------------------------------------------------------------------
x <- 1:5
x
## Summe
sum(x)
## Kumulative Summe
cumsum(x)
## Produkt
prod(x)
## Kumulatives Produkt
cumprod(x)

## ------------------------------------------------------------------------
x <- rnorm(10)
x
y <- rnorm(10)
y
## Minium
min(x)
min(y)
## auch mit beliebig vielen Argumenten
min(x, y)
## Kumulatives Minimum
cummin(x)
## Maximum
max(x)
max(y)
max(x, y)
## Kumulatives Maximum
cummax(x)
## vergleichendes Minimum bzw. Maximum
pmin(x, y)
pmax(x, y)
## Im Fall einfacher Vektoren sind folgende Funktionen effizienter/schneller
pmin.int(x, y)
pmax.int(x, y)

## ------------------------------------------------------------------------
x <- 100*rnorm(5)
x
## Runden auf 3 Nachkommastellen
round(x, 3)
## Runden auf 10er
round(x, -1)
## Abschneiden
trunc(x)
## Aufrunden
ceiling(x)
## Abrunden
floor(x)

## ------------------------------------------------------------------------
x <- rnorm(5)
x
## Umdrehen eines Vektors
rev(x)
## sortiere aufsteigend
sort(x)
## sortiere absteigend
sort(x, decreasing = TRUE)
## Ordnung - aufsteigend
sort.list(x)
## bzw.
order(x)
## Ordnung - absteigend
sort.list(x, decreasing = TRUE)
## bzw.
order(x, decreasing = TRUE)

## ------------------------------------------------------------------------
M <- matrix(c(rep(1:4, 2), 8:1), ncol = 2)
M
M[order(M[,1], M[,2]),]

## ------------------------------------------------------------------------
x <- c(4, 2, 3, 3, 1)
sort.list(x)
## mittelere Ränge (default)
rank(x)
## aufsteigende Ränge nach Reihenfolge des Vorkommens
rank(x, ties.method = "first")
## aufsteigende Ränge zufällig zugeordnet
rank(x, ties.method = "random")
## maximaler Rang
rank(x, ties.method = "max")
## minimaler Rang
rank(x, ties.method = "min")

## ------------------------------------------------------------------------
x <- rnorm(10)
x
x > 0
## gleiches Ergebnis
!(x <= 0)
(x > -1) & (x < 1)
(x < -1) | (x > 1)
## Verwendet wird nur der erste Eintrag der logischen Vektoren!
(x > -1) && (x < 1)
## bzw.
(x < -1) || (x > 1)
## enspricht also
(x[1] > -1) & (x[1] < 1)
## bzw.
(x[1] < -1) | (x[1] > 1)

## ------------------------------------------------------------------------
## irgendein Eintrag > 0
any(x > 0)
## alle Einträge > 0
all(x > 0)

## ------------------------------------------------------------------------
x <- sqrt(2)
x^2 == 2
x^2 - 2

## ------------------------------------------------------------------------
abs(x^2 - 2) <= 1e-15

## ------------------------------------------------------------------------
all.equal(x^2, 2, tolerance = 1e-15)

## ------------------------------------------------------------------------
x <- 1:5
x
y <- 1:5
names(y) <- letters[1:5]
y
identical(x, y) ## FALSE, wg. names-Attribut
## oder auch
all.equal(x, y)
## falls wir aber "nur" am Inhalt interessiert sind
all.equal(x, y, check.attributes = FALSE)

## ------------------------------------------------------------------------
isTRUE(all.equal(x, y))
## bzw.
isTRUE(all.equal(x, y, check.attributes = FALSE))

## ------------------------------------------------------------------------
0/0
log(-1)

## ------------------------------------------------------------------------
1/0
## Verteilungsfunktion der Normalverteilung
pnorm(Inf)
pnorm(-Inf)

## ------------------------------------------------------------------------
x <- c(NA, NaN, Inf, -Inf, 0)
x
## Test auf NA bzw. NaN
is.na(x)
## Test auf NaN
is.nan(x)
## Test auf Unendlich
is.infinite(x)
## bzw.
is.finite(x)

## ------------------------------------------------------------------------
x == 0

## ------------------------------------------------------------------------
y <- -3:3
y
#y<-2 ## was soll das bedeuten?
y < -2 ## ?
y
## bzw.
y<(-2) ## ?
y
## oder
y <- 2 ## ?
y

