## ------------------------------------------------------------------------
x <- 1:10
x
## Klammer nicht vergessen!
#x[-1:3] ## nein, sondern
x[-(1:3)]

## ------------------------------------------------------------------------
## Diagonalmatrix bzw. Einheitsmatrix
M <- diag(3)
M
## 1. Zeile
M[1,] ## -> Vektor
## 1. Spalte
M[,1] ## -> Vektor
## ABER!
M[1,,drop = FALSE] ## -> Zeilenvektor, Matrix mit einer Zeile
## bzw.
M[,1,drop = FALSE] ## -> Spaltenvektor, Matrix mit einer Spalte

## ------------------------------------------------------------------------
y <- replace(x, 1:3, -1)
y
## unverändert!
x

## ------------------------------------------------------------------------
z <- append(x, values = c(11, 12), after = length(x))
z
## entspricht auch
z <- c(x, 11, 12)
z
## aber auch Einfügen von Werten
z <- append(x, values = c(-10, -10), after = length(x)-2)
z

## ------------------------------------------------------------------------
x <- 1:3
x
y <- 1:6
y
x + y
M <- matrix(1:6, ncol = 2)
M
M * x
M ^ x
## oder auch
log2(2 ^ M)

## ------------------------------------------------------------------------
D <- diag(1:3)
D
rbind(D, rep(1, 3))
## oder auch
rbind(D, 1)
## entsprechend
cbind(D, -1)

## ------------------------------------------------------------------------
M <- matrix(1:6, ncol = 2)
M
t(M)

## ------------------------------------------------------------------------
A <- matrix(c(1, 2), ncol = 2, nrow = 2, byrow = TRUE)
A
B <- matrix(1:6, ncol = 2)
B
B %*% A
A %*% B ## nein, keine passenden Dimensionen!

## ------------------------------------------------------------------------
b <- c(3, 4)
A %*% b ## (2 x 2) * (2 x 1) = 2 x 1
b %*% A
## entspricht
t(b) %*% A ## (1 x 2) * (2 x 2) = 1 x 2

## ------------------------------------------------------------------------
b %*% b ## Ergebnis ist Matrix!
## alternative Methode - etwas langsamer
sum(b^2) ## Ergebnis ist Vektor!

## ------------------------------------------------------------------------
A
t(A) %*% A
## alternative Methode - schneller
crossprod(A)

## ------------------------------------------------------------------------
b %*% t(b)
## alternative Methode - etwa gleich schnell
b %o% b
## alternative Methode - etwa gleich schnell
outer(b, b)
## weitere Alternative - langsamer
tcrossprod(b)

## ------------------------------------------------------------------------
A
A %o% A
## oder
outer(A, A)

## ------------------------------------------------------------------------
x <- 1:5
x
y <- 1:3
y
## f(x,y) = x^2 + y^2
fkt <- function(x, y){ x^2 + y^2 }
## Auswertung auf allen Wertepaaren von x und y
outer(x, y, fkt)

## ------------------------------------------------------------------------
M <- matrix(c(1:9), ncol = 3)
M
## anwenden auf Zeilen (= Dimension 1)
apply(M, 1, sum)
## anwenden auf Spalten (= Dimension 2)
apply(M, 2, sum)
## Im Fall von Summe und Mittelwert besser/schneller!
rowSums(M)
colSums(M)
rowMeans(M)
colMeans(M)

## ------------------------------------------------------------------------
L <- list(a = rnorm(5), b = rnorm(5))
L
lapply(L, mean)
## entspricht lapply mit Vereinfachung des Ergebnisse - falls möglich
sapply(L, mean)
## oder aber
x <- rnorm(5)
x
sapply(x, exp) ## besser, schneller: exp(x)!

## ------------------------------------------------------------------------
replicate(3, rnorm(5))

## ------------------------------------------------------------------------
M
## subtrahiere von den Zeilen den Zeilenmittelwert
sweep(M, 1, rowMeans(M))
## subtrahiere von den Spalten den Spaltenmittelwert
sweep(M, 2, colMeans(M))

## ------------------------------------------------------------------------
A <- matrix(c(4, 1, 1, 9), ncol = 2)
A
b <- c(1, 2)
b
## Lösen des linearen Gleichungssystems Ax = b
solve(A, b)
## Matrixinversion
solve(A)
## Eigenwerte und Eigenvektoren
eigen(A)
## Determinante
det(A)
## bzw.
determinant(A, logarithm = FALSE)
## Spur (= Summe der Diagonalelemente) (nicht Funktion trace!)
sum(diag(A))
## Singulärwertzerlegung
svd(A)
## QR-Zerlegung
qr(A)
## Choleskizerlegung für pos. def. und symm. Matrizen
chol(A)
## Lösen eines linearen Gleichungssystems Ax = b mit A Dreiecksmatrix
backsolve(chol(A), b)

## ------------------------------------------------------------------------
## Vektor der Länge 0
character(0)
## Vektor der Länge 1 mit leerem Eintrag
vector(mode = "character", length = 1)
## bzw.
""

## ------------------------------------------------------------------------
"a" < "b"
## oder
"a" < "alpha"

## ----nchar---------------------------------------------------------------
x <- c("alpha", "beta", "", "gamma", "delta")
x
## Länge der in x enthaltenen Zeichenketten
nchar(x)
## nicht leere ("non-zero") Einträge
nzchar(x)

## ------------------------------------------------------------------------
paste(1:2, c(1,2), c("a", "b"), c(TRUE, FALSE), sep = " | ")
## oder auch
paste(c("x", "y"), "=", 1:2 + 3:4, sep = "")
## Erzeugen eines character-Vektors der Länge 1
paste(1:2, c(1,2), c("a", "b"), c(TRUE, FALSE), sep = " | ",
      collapse = ", ") ## Vektor der Länge 1!

## ------------------------------------------------------------------------
## Finde den Buchstaben p
grep("p", letters) ## Eintrag 16
## Klein- vs. Großschreibung
grep("p", LETTERS) ## kein "kleines" p enthalten
## Klein-/Großschreibung ignorieren
grep("p", LETTERS, ignore.case = TRUE)
## Andere Form des Ergebnisses
regexpr("p", letters)
gregexpr("p", letters[15:20])

## ------------------------------------------------------------------------
sub("k", "K", "Groß- und kleinschreibung")
gsub("n", "N", "Groß- und kleinschreibung")

## ------------------------------------------------------------------------
x <- "Ein Beispielstring"
x
substr(x, start = 5, stop = 12)
## oder
substring(x, first = 5, last = 12)
## Ersetzen
substr(x, start = 1, stop = 3) <- "Der"
x
## oder
substring(x, first = 1, last = 3) <- "Ein"
x

## ------------------------------------------------------------------------
x <- c("abcd", "efgh", "abce", "efhi")
x
## Gewünscht ist eine Länge von 2 Zeichen für die Abkürzungen
## Aber: unterschiedl. Ausgangsstrings -> unterschiedl. Abkürzungen
## Dies ist mit nur 2 Zeichen nicht möglich
abbreviate(x, 2)
## erzwingt Strings der Länge 2 -> Uneindeutigkeiten
abbreviate(x, 2, strict=TRUE)
## Abkürzung von beiden Seiten
abbreviate(x, 2, method = "both.sides")

## ------------------------------------------------------------------------
## ein Beispielverzeichnis
x <- "/usr/local/share/man"
x
## Aufteilen des Pfades in seine Bestandteile
strsplit(x, "/")
## Aufsplitten von Dateinamen in Name und Endung
x <- c("File1.exe", "File2.txt", "File3.pdf")
x
## Der Punkt . muss durch \\ maskiert werden
strsplit(x, "\\.")

## ------------------------------------------------------------------------
x <- rnorm(10)
## zum Beispiel, \t = Tabulator, \n = neue Zeile
cat("Der Mittelwert ist:\t", mean(x), "\n")
## oder
cat("Der Zahlenvektor lautete:", x, fill = TRUE)

## ------------------------------------------------------------------------
## z.B. einheitliche Stringlänge
formatC(x, digits = 4, format = "f", flag = " ")
## oder
y <- 10000*x
y
prettyNum(y, digits = 10, big.mark = ".", decimal.mark = ",")

## ------------------------------------------------------------------------
x <- rpois(15, lambda = 1)
y <- factor(letters[x+1])
y
x <- rpois(15, lambda = 1)
z <- factor(LETTERS[x+1])
z
## Absolute Häufigkeiten der Faktorlevels
table(y)
table(z)
## sog. Kreuztabelle
table(y, z)

## ------------------------------------------------------------------------
tabulate(y) ## Keine Information über die Levels!
tabulate(z)

## ------------------------------------------------------------------------
## Verwende CO2 Datensatz aus Paket MASS
library(MASS)
data(CO2)
## Mittlere CO2 Aufnahme für die verschiedenen Pflanzentypen
tapply(CO2[["uptake"]], CO2[["Plant"]], mean)
## oder auch
## Mittlere C02 Aufnahme in Abhängigkeit von der umgebenden
## CO2 Konzentration
tapply(CO2[["uptake"]], list(CO2[["conc"]], CO2[["Plant"]]), mean)

## ------------------------------------------------------------------------
## Verkleinerung von CO2 für Demonstrationszwecke
CO2.temp <- CO2[c(1,2,22,23,43,44,64,65),]
## Aufteilen des data.frames nach dem Faktor "Type"
split(CO2.temp, CO2.temp[["Type"]])
## Aufteilen des data.frames nach den Faktoren "Type" und "Treatment"
split(CO2.temp, list(CO2.temp[["Type"]], CO2.temp[["Treatment"]]))

