## ------------------------------------------------------------------------
## Der Operatoraufruf
3 - 2
## entspricht dem Funktionsaufruf
`-`(3, 2)

## ------------------------------------------------------------------------
## Die Zahl pi aus dem Paket base
pi
## neue Variable mit Namen pi, welcher der Wert 100 zugewiesen wird
pi <- 100
## Somit
pi

## ------------------------------------------------------------------------
## .GlobalEnv (Global Environment) vor package:base
search()

## ------------------------------------------------------------------------
base::pi

## ------------------------------------------------------------------------
## Lösche Variable pi aus dem Global Environment
rm(pi)
## R identifiziert den Namen pi mit der Konstante pi aus dem Paket base
pi

## ------------------------------------------------------------------------
## funktioniert nicht:
#1x <- 3!
## stattdessen
x1 <- 3
x1

## ------------------------------------------------------------------------
x <- 2; y <- 3; z <- 4
x
y
z

## ------------------------------------------------------------------------
## Mehrfachzuweisung
b <- a <- 6
a
b
## Rechtszuweisung
b <- 5
b -> a
b

## ------------------------------------------------------------------------
{
  a <- 2
  b <- 3
}
a
b

## ------------------------------------------------------------------------
###########################################################
## logischer Vektor der Länge 10
vec1 <- vector(mode = "logical", length = 10)
vec1
## oder kürzer
vec1 <- logical(10)
vec1
## interner Typ
typeof(vec1)
## Typ
mode(vec1)
## Speichertyp
storage.mode(vec1)
###########################################################
## integer (ganze Zahlen) Vektor der Länge 10
vec2 <- vector(mode = "integer", length = 10)
vec2
## oder kürzer
vec2 <- integer(10)
vec2
## interner Typ
typeof(vec2)
## Typ
mode(vec2)
## Speichertyp
storage.mode(vec2)
###########################################################
## numerischer (reelle Zahlen) Vektor der Länge 10
vec3 <- vector(mode = "numeric", length = 10)
vec3
## oder kürzer
vec3 <- numeric(10)
vec3
## interner Typ
typeof(vec3)
## Typ
mode(vec3)
## Speichertyp
storage.mode(vec3)
###########################################################
## komplexer (komplexe Zahlen) Vektor der Länge 10
vec4 <- vector(mode = "complex", length = 10)
vec4
## oder kürzer
vec4 <- complex(10)
vec4
## interner Typ
typeof(vec4)
## Typ
mode(vec4)
## Speichertyp
storage.mode(vec4)
###########################################################
## character (Zeichenketten) Vektor der Länge 10
vec5 <- vector(mode = "character", length = 10)
vec5
## oder kürzer
vec5 <- character(10)
vec5
## interner Typ
typeof(vec5)
## Typ
mode(vec5)
## Speichertyp
storage.mode(vec5)
###########################################################
## raw (Bytes) Vektor der Länge 10
vec6 <- vector(mode = "raw", length = 10)
vec6
## oder kürzer
vec6 <- raw(10)
vec6
## interner Typ
typeof(vec6)
## Typ
mode(vec6)
## Speichertyp
storage.mode(vec6)

## ------------------------------------------------------------------------
x <- c(1, 2, 3, 4)
x
typeof(x) ## per default: double/numeric nicht integer!

## ------------------------------------------------------------------------
## für integer hänge zusätzlich L an
x <- c(1L, 2L, 3L, 4L)
x
typeof(x)
## oder auch
y <- c("a", "b", "c", "d")
y

## ------------------------------------------------------------------------
## Vorgabe des Abstands zwischen den Zahlen
seq(from = 0, to = 1, by = 0.1)
## Vorgabe der Länge der Folge (äquidistant)
seq(from = 0, to = 1, length = 20)

## ------------------------------------------------------------------------
x <- seq_len(10)
x
typeof(x)
## oder aber
y <- 1:10
y
typeof(y)

## ------------------------------------------------------------------------
z <- -1.1:6.1
z

## ------------------------------------------------------------------------
## erstes Argument 3-mal wiederholt
rep(1:3, times = 3)
## jedes der Elemente des ersten Arguments 3-mal wiederholt
rep(c("a", "b", "c"), each = 3)
## Vorgabe der Länge des Ergebnisses
rep(1:3, length.out = 10)

## ------------------------------------------------------------------------
x <- seq_len(10)
x
## 3-tes Element
x[3]
## aber auch 4-tes bis 6-tes Element
x[4:6]
## oder auch mittels logischer Vektoren!
x[x > 5]
## wobei
x > 5
## Achtung!
x[11]
## Ändern des Inhalts
x[3] <- 5
x

## ------------------------------------------------------------------------
## Der Vektor der Länge 1 mit Inhalt 1 wird solange um sich selbst
## verlängert bis seine Dimension passend ist.
x[7:9] <- 1
x
## Achtung: auch folgendes funktioniert
x[1:5] <- c(1, 2)
x

## ------------------------------------------------------------------------
x
## Kleinbuchstaben
letters
## Großbuchstaben
LETTERS
## Wir verwenden a - j als Namen
names(x) <- letters[1:10]
x
attributes(x)

## ------------------------------------------------------------------------
x[c("a", "c")]

## ------------------------------------------------------------------------
comment(x) <- "Ein Test-Kommentar"
x ## bzw. print(x)
comment(x)

## ------------------------------------------------------------------------
attr(x, which = "meinNeuesAttribut") <- "ein neues Attribut"
x
attributes(x)

## ------------------------------------------------------------------------
length(x)

## ------------------------------------------------------------------------
vector(mode = "list", length = 5)

## ------------------------------------------------------------------------
L <- list(a = 1:3, bbb = letters[5:6], c(TRUE, FALSE), d = list(1, 2))
L
## names-Attribut
names(L)
## Länge
length(L)

## ------------------------------------------------------------------------
## Man beachte den Unterschied zwischen
L[1] ## Liste der Länge 1
## und
L[[1]] ## hier: Vektor, nämlich der Eintrag an Position 1 von L
## bzw. Zugriff mit Name und $-Operator
L$a
## partielles Matchen des Namens bbb
L$b[2]
## oder auch (hier kein partielles Matchen!)
L[["bbb"]]
## oder auch
L[[4]][[1]]

## ------------------------------------------------------------------------
unlist(L)
## oder
unlist(L, use.names = FALSE)
## oder kein rekursive Auflösen von Unterlisten
unlist(L, recursive = FALSE)

## ------------------------------------------------------------------------
## Vektor mit 12 (Pseudo-)Zufallszahlen aus einer Standardnormalverteilung
x <- rnorm(12)
x
## Transformiere in eine Matrix mit 2 Zeilen und 6 Spalten
dim(x) <- c(2, 6)
x
## Transformiere in ein Array der Dimension 2 x 2 x 3
dim(x) <- c(2, 2, 3)
x

## ------------------------------------------------------------------------
## Matrizen werden per default spaltenweise gefüllt!
matrix(1:6, nrow = 2, ncol = 3)
## Es genügt jedoch auch nur nrow oder ncol anzugeben
matrix(letters[1:6], nrow = 2)
## bzw.
matrix(LETTERS[1:6], ncol = 3)
## Man kann jedoch auch zeilenweises Auffüllen "erzwingen"
matrix(1:6, nrow = 2, byrow = TRUE)
## Zyklisches Auffüllen!
matrix(c(TRUE, FALSE), nrow = 6, ncol = 2)

## ------------------------------------------------------------------------
array(1:16, dim = c(2, 2, 2, 2))
## Zyklisches Auffüllen!
array(1:8, dim = c(2, 2, 2, 2))

## ------------------------------------------------------------------------
M <- matrix(1:6, ncol = 2)
M
## Element (3,1)
M[3,1]
## 1. Zeile
M[1,]
## 2. Spalte
M[,2]
## Auswahl per logischer Matrix => Ergebnis: Vektor!
M[M > 2]
## Nützlich insbesondere für Ersetzungen
M[M > 2] <- 10
M

## ------------------------------------------------------------------------
row(M)
col(M)
## zum Beispiel "Hauptdiagonale"
M[row(M) == col(M)]

## ------------------------------------------------------------------------
dim(M)
## Anzahl Zeilen
nrow(M)
## Anzahl Spalten
ncol(M)

## ------------------------------------------------------------------------
rownames(M) <- letters[1:3]
colnames(M) <- LETTERS[1:2]
M
## Zugriff mit Hilfe der Namen
M["a", "A"]

## ------------------------------------------------------------------------
A <- array(1:8, dim = c(2, 2, 2),
           dimnames = list(rownames = c("a", "b"),
                           colnames = c("A", "B"),
                           names3 = c("X", "Y")))
A
rownames(A)
colnames(A)
attr(A, which = "dimnames")
## Alternative: nachträgliches Setzen (bzw. Verändern)
A <- array(9:16, dim = c(2, 2, 2))
attr(A, which = "dimnames") <- list(names1 = c("a", "b"),
                                    names2 = c("A", "B"),
                                    names3 = c("X", "Y"))
A
rownames(A)
colnames(A)
## oder auch
A <- array(9:16, dim = c(2, 2, 2))
attr(A, which = "dimnames") <- list(c("a", "b"), c("A", "B"),
                                    c("X", "Y"))
A
rownames(A)
colnames(A)

## ------------------------------------------------------------------------
x <- 1:5
x
levels(x) <- 1:5
x ## noch kein Faktor
## Fehlt noch Setzen der S3-Klasse/des class-Attributs
class(x) <- "factor"
x
###########################################################
## einfacher
y <- factor(1:5)
y
## alle Attribute
attributes(y)
## nur das levels-Attribut
levels(y)
## Anzahl von levels
nlevels(y)

## ------------------------------------------------------------------------
## man beachte das levels-Attribut!
x[1:3]

## ------------------------------------------------------------------------
## man beachte das levels-Attribut!
factor(x[1:3])

## ------------------------------------------------------------------------
x[1] <- 6
x

## ------------------------------------------------------------------------
x <- factor(sample(letters[1:5], 20, replace = TRUE), levels = letters[1:7])
x

## ------------------------------------------------------------------------
table(x)

## ------------------------------------------------------------------------
is.ordered(x)
## Einführung einer alphabetischen Ordnung durch Neudefinition
## Achtung: die Kategorien f und g verschwinden dabei!
ordered(x)
## besser: explizite Vorgabe der Ordnung
y <- factor(x, levels = c("c", "b", "d", "g", "f", "a", "e"), ordered = TRUE)
y
## oder
y <- ordered(x, levels = c("c", "b", "d", "g", "f", "a", "e"))
y
## absolute Häufigkeiten
table(y)
## alle Attribute
attributes(y)

## ------------------------------------------------------------------------
## Anlegen eines data.frame mit den Spalten Wert, Gruppe und Name
D <- data.frame(Wert = rnorm(10),
                Gruppe = factor(c(rep("a", 5), rep(2, 5))),
                Name = LETTERS[1:10])
D
attributes(D)

## ------------------------------------------------------------------------
names(D)
colnames(D)
rownames(D)

## ------------------------------------------------------------------------
## Element (4,1)
D[4,1]
## 1-te Zeile
D[1,]
## 2-te Spalte
D[,2]
## oder
D$Wert
## Achtung: partielles Matchen
D$G
## besser/empfohlen
D[,"Gruppe"]

## ------------------------------------------------------------------------
str(D)

## ------------------------------------------------------------------------
D[,"Name"]
D.neu <- data.frame(Wert = rnorm(10),
                    Gruppe = factor(c(rep("a", 5), rep(2, 5))),
                    Name = LETTERS[1:10],
                    stringsAsFactors = FALSE)
D.neu[,"Name"]

## ------------------------------------------------------------------------
dim(D)
ncol(D)
nrow(D)

## ------------------------------------------------------------------------
as.matrix(D) ## character Matrix
data.matrix(D) ## numerische Matrix

## ------------------------------------------------------------------------
## ganze Zahlen werden standardmäßig als reelle Zahlen interpretiert
is.integer(3)
## Umwandlung in ganze Zahl
as.integer(3.1415)
## oder auch
as.integer("3.1415")
## bzw.
as.numeric("3.1415")
## umgekehrt
as.character(pi)

## ------------------------------------------------------------------------
## Eine einfache Funktion ohne Argumente
hello <- function(){
  print("Hello World!")
}
hello()

## ------------------------------------------------------------------------
hello

